; File: NASMTEST.ASM

; Author: Matthew Mastracci

; Purpose: Implements many of the concepts described in the first section of
; DJGPPASM.DOC

[BITS 32]

[GLOBAL _AddFour__FUi]
[GLOBAL _NewVersion__Fc]
[GLOBAL _PrintStrings__Fv]
[GLOBAL _VersionString]
[GLOBAL _DataValues]
[EXTERN _printf]
[EXTERN _Exported]

[SECTION .text]

; ---------------------------------------------------------------------------
; Prototype: unsigned int AddFour(unsigned int x);
; Returns: x + 4
; ---------------------------------------------------------------------------

x_AddFour       equ 8

_AddFour__FUi:
        push ebp
        mov ebp, esp
               
        mov eax, [ebp + x_AddFour]
        add eax, [AddConstant]

        mov esp, ebp
        pop ebp
        ret

; ---------------------------------------------------------------------------
; Prototype: void NewVersion(char c);
; Returns: nothing
; ---------------------------------------------------------------------------

c_NewVersion    equ 8

_NewVersion__Fc:
        push ebp
        mov ebp, esp

        mov al, [ebp + c_NewVersion]
        mov byte [_VersionString + 26], al

        mov esp, ebp
        pop ebp
        ret

; ---------------------------------------------------------------------------
; Prototype: void PrintStrings(void);
; Returns: nothing
; ---------------------------------------------------------------------------

_PrintStrings__Fv:
        push ebp
        mov ebp, esp

        push dword _VersionString
        push dword PrintTemplate1
        call _printf

        push dword [_Exported]
        push dword PrintTemplate2
        call _printf

        mov esp, ebp
        pop ebp
        ret

[SECTION .data]

AddConstant     dd 00000004h

_VersionString   db "NASMTEST.ASM - Version 0.0a", 00h

_DataValues:
        dd      00000001        ; x
        dd      00000002        ; y
        dd      _VersionString  ; Offset of version string, effectively a 
                                ; pointer

PrintTemplate1  db "VersionString = '%s'", 0ah, 00h
PrintTemplate2  db "unsigned int Exported = 0x%08x", 0ah, 00h
